VERSION 8000;;8407
* Allg_BspDialogAuswahllisten.CSX    30.11.11
* -----------------------------------------------------------------------------
* @filedoc
* @file Allg_BspDialogAuswahllisten.CSX
* @brief <Dialog mit Listenauswahlbuttons>
* 
* <Dieser Dialog enthlt ein Text- und ein Wertfeld mit Listenauswahlfeld fr einfache 
*  Auswahl, und einen Button, ber den mehrere Eintrge (hier: Schichten) aus einer Auswahlliste 
*  gewhlt werden knnen.
*  Der Dialog ist in der Funktion Dialog_Auswahl definiert.
*  Die Auswahlliste fr die Mehrfachauswahl wird in der Funktion GetMulti_Schicht erstellt.
*  Die Funktion Info_ChooseMulti ermittelt die Anzahl der ausgewhlten(markierten) Listeneintrge.
*   >
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author Ch
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------
* 
BILDSCHIRM GRAFIK
*
* Deklarationen
SYMBOLE  /GENERALCHOICE/ MChoice; WChoice; TChoice
SYMBOLE * Id;Status;!Name;!Bez;!Textwert;Zahlwert

* Auswahlliste fr Mehrfachauswahl anlegen und Schichten eintragen
MChoice = NewObject /GENERALCHOICE/
MChoice = GetMulti_Schicht()

* Dialog aufrufen
Status = Dialog_Auswahl()

* Ergebnis 
WENN Status == 0 DANN STOP MELDE "Dialog abgebrochen"
MELDE " Textauswahl: #";!Textwert                            | Wert des Textfeldes protokollieren  
MELDE " Wertauswahl: #.###";Zahlwert                         | Wert des Zahlenfeldes protokollieren   
MELDE " Ergebnis: markierte Eintrge der Auswahl" 
Id = 0
SOLANGE Id = MChoice.GetNextId(Id)                   | markierte Eintrge der Auswahlliste auswerten          
  !Name = MChoice.GetName(Id)                    
  !Bez = MChoice.GetText(Id)
  MELDE " ID: ##### Name: '#' Bezeichnung: '#'";Id;!Name;!Bez | markierte Eintrge protokollieren
ENDE SOLANGE
*
STOP
* -----------------------------------------------------------------------------
* @function Dialog_Auswahl
* @brief <Dialog mit Feldern fr Text und Zahlenwert mti Listenauswahlbutton
*         fr die Auswahl eines Eintrags aus einer mit /GENERALCHOICE/ erstellten Liste
*         und einem Button, der eine Schichtauswahlliste fr Mehrfachauswahl ffnet>
* @ingroup
* @author Ch
* @endfunction
FUNKTION Dialog_Auswahl:

* Deklarationen
  SYMBOLE /DLG_WINDOW/ Dialog
  SYMBOLE /DLG_BUTTON/ MultiButt
  SYMBOLE /DLG_NUMBER/ Zahlfeld
  SYMBOLE /DLG_TEXT/ Textfeld
  SYMBOLE * Ret;Anz_Mark
  EXTERN  /GENERALCHOICE/ MChoice; WChoice; TChoice
  EXTERN  * ID;!Textwert;Zahlenwert;!Name;!Bez
  
* .................Dialog anlegen
  Dialog = NewObject /DLG_WINDOW/
  Dialog.SetCaption("Dialog")

* .................Textfeld mit Listenauswahl
  * Auswahlliste zusammenstellen 
  TChoice = newObject /GENERALCHOICE/
  TChoice.SetSortMode(0)
  TChoice.SetCaption("Auswahl eines Wochentags")
  TChoice.AddItem("Montag"; "")
  TChoice.AddItem("Dienstag"; "")
  TChoice.AddItem("Mittwoch"; "")
  TChoice.AddItem("Donnerstag"; "")
  TChoice.AddItem("Freitag"; "")
  TChoice.AddItem("Sonnabend"; "")
  TChoice.AddItem("Sonntag"; "")
  * Textfeld erstellen
  TextFeld = NewObject /DLG_TEXT/
  TextFeld.SetLabel("Text:")
  TextFeld.SetText(" ")
  TextFeld.SetSize(20)
  TextFeld.SetGeneralChoice(TChoice)   | Listenauswahlbutton an Textfeld anhngen
  Dialog.AddField(Textfeld)
* .................Zahlfeld mit Listenauswahl
  * Auswahlliste zusammenstellen 
  WChoice = newObject /GENERALCHOICE/
  WChoice.SetSortMode(0)
  WChoice.SetCaption("Auswahl eines Wertes")
  WChoice.AddItem("";"nichts ($UNDEF)")
  WChoice.AddItem("123.456";"toller Wert")
  WChoice.AddItem("0.0";"nichts (Null)")
  WChoice.AddItem("123456.789";"groer Wert")
  WChoice.AddItem("-789.321";"kleiner Wert")
  * Zahlfeld erstellen
  Zahlfeld = NewObject /DLG_NUMBER/
  Zahlfeld.SetLabel("Wert:")
  Zahlfeld.SetSize(20; 3)
  Zahlfeld.EnableUndef()
  Zahlfeld.SetValue($UNDEF )
  Zahlfeld.SetGeneralChoice(WChoice)   | Listenauswahlbutton an Zahlenfeld anhngen
  Dialog.AddField(Zahlfeld)

* .................Button mit Mehrfachauswahlliste
  MultiButt = NewObject /DLG_BUTTON/ 
  MultiButt.SetCaption("Schichten whlen")
  MultiButt.SetGeneralChoice(MChoice)  | Button mit Multiauswahlliste belegen
  DIALOG.AddButton(MultiButt)
  
* Dialog ausfhren
  RET = Dialog.DoDialog(1)
* Ergebnis
  WENN Ret DANN
    !Textwert = Textfeld.GetText()           | Text aus Textfeld ermitteln
    Zahlwert = Zahlfeld.GetValue()           | Wert aus Zahlenfeld ermitteln 
      Anz_Mark = Info_ChooseMulti(MChoice)   | Anzahl der markierten Eintrge aus Liste ermitteln
      MELDE "# Eintrge markiert";ANZ_Mark 
   WEITER   
   ZURCK Ret
ENDE FUNKTION

* -----------------------------------------------------------------------------
* @function GetMulti_Schicht
* @brief <Funtkion erstellt eine Auswahltabelle aller Schichten des Projekts>
* CHOICE ID = Generiert
* @return {/GENERALCHOICE/}
* @retval = 
* @ingroup
* @author Jo
* @endfunction
FUNKTION {/GENERALCHOICE/} GetMulti_Schicht:

* Deklarationen
  SYMBOLE /GENERALCHOICE/ MChoice
  SYMBOLE /TOPOSYS/ TopoSys
  SYMBOLE /TOPOLAYER/ Schicht
  SYMBOLE * LF
  EXTERN  * ID;!Name;!Bez
* 
  TopoSys = Project.GetTopoSys()
* Auswahlliste anlegen  
  MChoice = NewObject /GENERALCHOICE/
  MChoice.SetSortMode(1)      | Sortierung nach Reihenfolge: Key=0; Sortierung nach Name: Key=1
  MChoice.SetCaption("Auswahl von Schichten")
  MChoice.SetHeadLine("Name";"Bezeichnung")
  LF=0
  Schicht = $NULL
  * vorh. Schichten lesen und in Auswahlliste eintragen
  SOLANGE Schicht = TopoSys.GetNextLayer(Schicht)    
    LF=LF+1
    !Name= Schicht.GetName()
    !Bez = Schicht.GetDescription()
    MChoice.AddItem(!Name; !Bez; LF)
  ENDE SOLANGE 
ZURCK MChoice
ENDE FUNKTION
* -----------------------------------------------------------------------------
* @function Info_ChooseMulti
* @brief <markierte Eintrge der Auswahlliste auswerten>
* CHOICE Id = generiert
* @param AChoice: 
* @ingroup
* @author Jo
* @endfunction
FUNKTION Info_ChooseMulti: {/GENERALCHOICE/} AChoice
* Deklarationen
  SYMBOLE * NP 
  EXTERN * Id
* Werte vorbelegen
  NP = 0
  ID = 0
* Schleife zum zhlen der markierten Listeneintrge
  SOLANGE Id = AChoice.GetNextID(Id)
    WENN AChoice.IsMarked( Id ) Dann 
      NP = NP +1
    WEITER
  ENDE SOLANGE
  ZURCK NP
ENDE FUNKTION
* -----------------------------------------------------------------------------

